#!/bin/bash

# updated by WIBOON 2556-04-15

if [ -z "$(id -nG|grep -w "root")" ] ; then
  echo "need root, or try: sudo sh $0"
  exit
fi
if [ ! -z "$(grep usrquota /etc/fstab)" ] ; then
  echo "Disk quota system is already installed."
  exit 
fi
sudo apt-get install quota -y

save_exist_file(){
  TARGET="$1"
  if [ -f ${TARGET} ]; then
      INFO=$(ls -clQ --time-style=long-iso ${TARGET})
      CTIME=$(echo ${INFO}|awk '{ print $6"-"$7 }')
      NAME=$(echo "${TARGET}_${CTIME}")
      sudo cp -v ${TARGET} ${NAME}
  fi
}

save_exist_file "/etc/fstab"
sed -i '/^UUID=.* \//s/errors=remount-ro/usrquota,grpquota,errors=remount-ro/g' /etc/fstab
sudo touch /aquota.user /aquota.group
sudo chmod 600 /aquota.user /aquota.group
sudo mount -o remount /
sudo quotacheck -F vfsv0 -afcvdugm
sudo quotaon -a
echo "filename: /etc/fstab"
echo -n "\033[32m"
echo "------------------------------------------------------------------------"
cat /etc/fstab
echo "------------------------------------------------------------------------"
echo -n "\033[00m"
echo "\033[31m==> PLEASE CHECK /etc/fstab above, you should see a line like below\033[00m"
echo -n "\033[32m"
echo "------------------------------------------------------------------------"
echo "UUID=xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx /               ext4    usrquota,grpquota,errors=remount-ro 0"
echo "------------------------------------------------------------------------"
echo -n "\033[00m"
echo "Disk quota system was installed successfully."
