#!/bin/bash

#updates by WIBOON 2556-04-17

#Add multiple users with bulk import
#You can import multiple users into PSU-netdrive file server from a single file source. The file must be a text file and adhere to the required format. 
#For example 
#Filename: usergroup1
#user1
#user2
#user3
#
#When finished, the original filename will be replace with a filename_timestamp.csv consists of lines with username:password format.

exitusage()
{
  echo "usage: sudo sh $0 path/to/filename"
  echo "path/to/filename is a file consists of one username per line i.e."
  echo "user1"
  echo "user2"
  exit 
}

if [ -z "$(id -nG|grep -w "root")" ] ; then
  echo "need root, or try: sudo sh $0"
  exit
fi
if [ "$1" = "--help" ] ; then
  exitusage
fi
if [ -z "$1" ] ; then
  echo "need filename"
  exitusage
fi

TODAY=$(date "+%Y%m%d%H%M")
IN_FILENAME=$1
HOME_DIR="/sftp/home"
OUT_FILENAME=${IN_FILENAME}_${TODAY}.csv

if [ ! -f ${IN_FILENAME} ] ; then
  echo "File not found"
  exit
fi

sudo touch ${OUT_FILENAME}

for USERDETAILS in $(cat ${IN_FILENAME})
do
  MYUSER="$(echo ${USERDETAILS})"
  PASSWD="$(apg -n 1 -a 1 -M nL -m 10 -x 10 -E ijl0oqg)"
  echo "...Processing adding user ${MYUSER}"
  if [ ! -z "$(getent passwd ${MYUSER})" ]; then
    echo "username exist"
    sudo echo "${MYUSER}:invalid" >> ${OUT_FILENAME}
  else
    sudo sh /root/netuseradd.sh ${MYUSER} -p ${PASSWD}
    sudo echo "${MYUSER}:${PASSWD}" >> ${OUT_FILENAME}
  fi
  sleep 1
done
sudo chmod go-rwx ${OUT_FILENAME}
sudo rm -f ${IN_FILENAME}
echo "Finished, the original filename ${IN_FILENAME} replaced with ${OUT_FILENAME} consists of lines with username:password format."
#END

