#!/bin/bash

# updated by WIPAT 2555-02-27

# usage: sudo check-shadow.sh 'username' 'password'
# output true = correct , false = incorrect
USER=$1
MYPASS=$2
SHADOWFILE="/etc/shadow"
if [ -z "$2" ] ; then
  echo "false"
  exit 2
fi
BASEPASS=$(grep "^${USER}:" ${SHADOWFILE} )
if [ -z "${BASEPASS}" ] ; then
  echo "false"
  exit 1
fi
DECODEPASS=$(echo "${BASEPASS}"|cut -d':' -f 2)
TYPE=$(echo "${DECODEPASS}"|cut -c 1-2)
case ${TYPE} in
  '$1' ) METHOD="md5" ;;
  '$5' ) METHOD="sha-256" ;;
  '$6' ) METHOD="sha-512" ;;
  * ) METHOD="des" ;;
esac
if [ "${METHOD}" = "des" ] ; then
  SID=${TYPE}
else
  SID=$(echo "${DECODEPASS}"|cut -d '$' -f 3)
fi
GENPASS=$(mkpasswd -m ${METHOD} -S ${SID} ${MYPASS})
if [ "${DECODEPASS}" = "${GENPASS}" ] ; then
  echo "true"
  exit 0
fi
echo "false"
exit 3 
